searchNodes=[{"doc":"SanityWebhookPlug is a Plug that verifies Sanity webhooks for your Elixir Plug application. Designed to work with Sanity GROQ-powered webhooks Installation def deps do [ { :sanity_webhook_plug , &quot;~&gt; 0.1.4&quot; } ] end Usage Use this plug in your endpoint: # If using Plug or Phoenix, place before `plug Plug.Parsers` # For Phoenix apps, in lib/my_app_web/endpoint.ex: plug SanityWebhookPlug , at : &quot;/webhooks/sanity&quot; , handler : MyAppWeb.SanityWebhookHandler You may alternatively configure the secret in config, which will be read during runtime: # in config/runtime.exs config :sanity_webhook_plug , webhook_secret : System . get_env ( &quot;SANITY_WEBHOOK_SECRET&quot; ) Define a handler to handle webhooks: defmodule MyAppWeb.SanityWebhookHandler do @behaviour SanityWebhookPlug.Handler alias Plug.Conn # see below for an example using Phoenix @impl SanityWebhookPlug.Handler def handle_event ( conn , params ) do # Process and return the conn conn |&gt; Conn . put_resp_header ( &quot;content-type&quot; , &quot;application/json&quot; ) |&gt; Conn . send_resp ( 200 , Jason . encode! ( %{ success : &quot;yay!&quot; } ) ) end @impl SanityWebhookPlug.Handler def handle_error ( conn , error ) do # Process and return the conn conn |&gt; Conn . put_resp_header ( &quot;content-type&quot; , &quot;application/json&quot; ) |&gt; Conn . send_resp ( 500 , Jason . encode! ( %{ error : &quot;uh oh!&quot; } ) ) end end Options: :at (required): The request path to match against. eg, &quot;/webhooks/sanity&quot; :handler (required): The controller-like module that responds to handle_event/2 that is passed the conn and the params, and handle_error/2 that is passed the conn and the error. The error may be an exception or a string. :secret : The Sanity webhook secret. eg: 123abc . Supplying an MFA tuple will be called at runtime, otherwise it will be compiled. If not set, it will obtain via Application.get_env(:sanity_webhook_plug, :webhook_secret) . If supplying an MFA or function reference, it must return {:ok, my_secret} or a string. :json_decoder : JSON encoding library. When not supplied, it will use choose Phoenix's configured library, Jason , or Poison . Sanity requires JSON-encoded responses. Options forwarded to Plug.Conn.read_body/2 : :length - sets the number of bytes to read from the request at a time. :read_length - sets the amount of bytes to read at one time from the underlying socket to fill the chunk. :read_timeout - sets the timeout for each socket read. Verifying the signature requires reading the body, but its best to do this before interpreting the body into JSON or other parsed formats. Plug can protect your system by limiting how much of body to read to prevent exhaustion. Ideally, any of these settings you have for Plug.Parsers in your endpoint, you should also have for SanityWebhookPlug. The body and query params will be merged and given to your handler, which matches Phoenix behavior. Example An example using Phoenix ## In lib/my_app_web/endpoint.ex # place before Plug.Parsers defmodule MyAppWeb.Endpoint do use Phoenix.Endpoint , otp_app : :my_app # ... plug SanityWebhookPlug , at : &quot;/webhooks/sanity&quot; , handler : MyAppWeb.SanityWebhookHandler # Plug.Parsers down here somewhere end ## in lib/my_app_web/controllers/sanity_webhook_handler.ex def MyAppWeb.SanityWebhookHandler do use MyAppWeb , :controller require Logger @behaviour SanityWebhookPlug.Handler # handle known events def handle_event ( conn , %{ &quot;_type&quot; =&gt; type , &quot;_id&quot; =&gt; id } ) do # do something json ( conn , %{ success : &quot;Did the thing!&quot; } ) end def handle_event ( conn , params ) do Logger . warn ( &quot;SanityWebhook: unhandled webhook: \#{ inspect ( params ) } &quot; ) conn |&gt; put_status ( 500 ) |&gt; json ( %{ error : &quot;unhandled webhook&quot; } ) end def handle_error ( conn , error ) do debug = SanityWebhookPlug . get_debug ( conn ) Logger . error ( &quot;SanityWebhook error: \#{ inspect ( debug ) } &quot; ) conn |&gt; put_status ( 400 ) |&gt; json ( %{ error : inspect ( error ) } ) end end","ref":"SanityWebhookPlug.html","title":"SanityWebhookPlug","type":"module"},{"doc":"Process the conn for a Sanity Webhook and verify its authenticity.","ref":"SanityWebhookPlug.html#call/2","title":"SanityWebhookPlug.call/2","type":"function"},{"doc":"Get the Sanity Webhook debug information from the conn.","ref":"SanityWebhookPlug.html#get_debug/1","title":"SanityWebhookPlug.get_debug/1","type":"function"},{"doc":"The expected request header that contains the Sanity webhook signature and timestamp","ref":"SanityWebhookPlug.html#header/0","title":"SanityWebhookPlug.header/0","type":"function"},{"doc":"Initialize SanityWebhookPlug options.","ref":"SanityWebhookPlug.html#init/1","title":"SanityWebhookPlug.init/1","type":"function"},{"doc":"Generate a request header tuple compatible with Sanity webhook systems. Timestamp can be either a %DateTime{} or a unix timestamp in milliseconds. { &quot;sanity-webhook-signature&quot; , &quot;ts=123,v1=abc123signature&quot; }","ref":"SanityWebhookPlug.html#make_header/3","title":"SanityWebhookPlug.make_header/3","type":"function"},{"doc":"","ref":"SanityWebhookPlug.html#t:t/0","title":"SanityWebhookPlug.t/0","type":"type"},{"doc":"Behaviour for handling webhooks from SanityWebhookPlug","ref":"SanityWebhookPlug.Handler.html","title":"SanityWebhookPlug.Handler","type":"behaviour"},{"doc":"Handle inauthentic or erroneous webhooks","ref":"SanityWebhookPlug.Handler.html#c:handle_error/2","title":"SanityWebhookPlug.Handler.handle_error/2","type":"callback"},{"doc":"Handle authenticity-validated webhooks","ref":"SanityWebhookPlug.Handler.html#c:handle_event/2","title":"SanityWebhookPlug.Handler.handle_event/2","type":"callback"},{"doc":"","ref":"SanityWebhookPlug.Handler.html#t:error/0","title":"SanityWebhookPlug.Handler.error/0","type":"type"},{"doc":"","ref":"SanityWebhookPlug.Handler.html#t:params/0","title":"SanityWebhookPlug.Handler.params/0","type":"type"},{"doc":"Compute and verify signatures from Sanity webhooks","ref":"SanityWebhookPlug.Signature.html","title":"SanityWebhookPlug.Signature","type":"module"},{"doc":"","ref":"SanityWebhookPlug.Signature.html#base64url_decode/1","title":"SanityWebhookPlug.Signature.base64url_decode/1","type":"function"},{"doc":"","ref":"SanityWebhookPlug.Signature.html#base64url_encode/1","title":"SanityWebhookPlug.Signature.base64url_encode/1","type":"function"},{"doc":"Compute the signature for Sanity webhooks","ref":"SanityWebhookPlug.Signature.html#compute/3","title":"SanityWebhookPlug.Signature.compute/3","type":"function"},{"doc":"Verify a payload, timestamp, and secret against a computed signature","ref":"SanityWebhookPlug.Signature.html#verify/4","title":"SanityWebhookPlug.Signature.verify/4","type":"function"},{"doc":"","ref":"SanityWebhookPlug.Signature.html#t:secret/0","title":"SanityWebhookPlug.Signature.secret/0","type":"type"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Update project URLs","ref":"changelog.html#0-1-4-2023-03-24","title":"Changelog - 0.1.4 (2023-03-24)","type":"extras"},{"doc":"Correct documentation","ref":"changelog.html#0-1-3-2023-01-25","title":"Changelog - 0.1.3 (2023-01-25)","type":"extras"},{"doc":"Skip halted conns Add make_header/3 function","ref":"changelog.html#0-1-2-2023-01-23","title":"Changelog - 0.1.2 (2023-01-23)","type":"extras"},{"doc":"Halt conn after successful event","ref":"changelog.html#0-1-1-2023-01-09","title":"Changelog - 0.1.1 (2023-01-09)","type":"extras"},{"doc":"Initial release :tada:","ref":"changelog.html#0-1-0-2023-01-06","title":"Changelog - 0.1.0 (2023-01-06)","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright [yyyy] [name of copyright owner] Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]